// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "WordHTML.h"

#include "MainFrm.h"
#include ".\mainfrm.h"

#include "WordHTMLDoc.h"
#include "WordHTMLView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CMainFrame
CString GetModuleDirectory();
CString ExtractFile(CString path);

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	ON_WM_CREATE()
	ON_WM_DROPFILES()	
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};


// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	// TODO: add member initialization code here
	fileArray.RemoveAll();
	accessingBuffer = 0;
}

CMainFrame::~CMainFrame()
{
	fileArray.RemoveAll();
}


int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	if (!m_wndToolBar.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_TOP
		| CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}
	// TODO: Delete these three lines if you don't want the toolbar to be dockable
	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);

	//m_wndToolBar.ShowWindow(SW_HIDE);

	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CFrameWnd::PreCreateWindow(cs) )
		return FALSE;
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	/*
	HDC hdc = ::GetDC(NULL);
	int widthx = GetDeviceCaps(hdc,HORZRES);
	::ReleaseDC(NULL,hdc);

	if (widthx<1000)
	{
		cs.cx =600;
		cs.cy = 560;
	}
	*/

		cs.cx =600;
		cs.cy = 670;
	


	return TRUE;
}


// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG


// CMainFrame message handlers


CString CMainFrame::TestExt(CString filename)
{
	CString xstr =  filename;
	xstr.MakeUpper();
	int lenx = xstr.GetLength();
	if (lenx<4)
		return _T("");

	if ((xstr[lenx-1]=='C') &&
		(xstr[lenx-2]=='O') &&
		(xstr[lenx-3]=='D'))
		return filename;

	return _T("");

}



void CMainFrame::OnDropFiles(HDROP hDropInfo)
{
	// TODO: Add your message handler code here and/or call default

	while (accessingBuffer)
		Sleep(100);
    
	accessingBuffer = 1;

	fileArray.RemoveAll();

	CString fileStr;
	TCHAR fileBuffer[1024];
	int sx = DragQueryFile(hDropInfo, 0xFFFFFFFF,fileBuffer,1024);
	for (int i=0;i<sx;i++)
	{
		
		DragQueryFile(hDropInfo,i,fileBuffer,1024);
		fileStr = fileBuffer;
		fileStr = TestExt(fileStr);
		if (fileStr!=_T(""))
		{			
			fileArray.Add(fileStr);

		}

		

	}
	
	sx = fileArray.GetCount();
	if (sx<=0)
	{
		accessingBuffer = 0;
		CFrameWnd::OnDropFiles(hDropInfo);
		return;
	}
	else
		DragAcceptFiles(0);


	TCHAR buffer[9216]; //9k
	CString directoryX = GetModuleDirectory();
	CString pathx = directoryX + "\\template.htm";
	FILE* fp = fopen(pathx,"rb");
	if (fp)
	{
		//memset(buffer,0,9216);
		int rr = fread(buffer,1,9216,fp);			
		if (rr<9216)
			buffer[rr] =0 ;

		fclose(fp);

	}
	else
	{
		accessingBuffer = 0;
		CFrameWnd::OnDropFiles(hDropInfo);
		return;
	}


	CString templateStr = buffer;
	int findx = templateStr.Find("<FIELDX>",0);
	if (findx>=0)
	{	
		sx = fileArray.GetSize();
		for (int i=0;i<sx;i++)
		{
			
				CString fileStrX =  fileArray[i];			
				CString insertStr;
				if ((i % 2)==0)
				{
					//insertStr = "<TR><TD style=\"WIDTH: 61px\" bgColor=\"white\"><FONT face=\"Tahoma\"><STRONG></STRONG></FONT></TD><TD bgColor=\"yellow\">" +  fileStrX  + "</TD></TR>";			

					insertStr = "<TR><TD bgColor=\"gold\"><FONT face=\"Tahoma\" Size = 2>&nbsp;<strong>" +  fileStrX  + "</strong></font></TD>";			

					
					CString folderStr;					
					folderStr = fileStrX + "_HTML";
					CString displayStr = ExtractFile(folderStr);
					insertStr += "<TD bgColor=\"orange\"><FONT face=\"Tahoma\" Size = 2>&nbsp;<strong><a href=\"" +  folderStr + "\" TARGET = \"_blank\">" + displayStr + "</a></strong></font>" + "</TD></TR>";			
					

				}
				else
				{
					//insertStr = "<TR><TD style=\"WIDTH: 61px\" bgColor=\"gray\"><FONT face=\"Tahoma\"><STRONG></STRONG></FONT></TD><TD bgColor=\"white\">" +  fileStrX  + "</TD></TR>";			
					insertStr = "<TR><TD bgColor=\"orange\"><FONT face=\"Tahoma\" Size = 2>&nbsp;<strong>" +  fileStrX  + "</strong></font></TD>";			

					CString folderStr;					
					folderStr = fileStrX + "_HTML";
					CString displayStr = ExtractFile(folderStr);
					insertStr += "<TD bgColor=\"gold\"><FONT face=\"Tahoma\" Size = 2>&nbsp;<strong><a href=\"" +  folderStr + "\" TARGET = \"_blank\">" + displayStr + "</a></strong></font>" + "</TD></TR>";			


				}
				templateStr.Insert(findx,insertStr);				

			
		}

	}


	
	srand( (unsigned)time( NULL ) );
	int val = rand();
	//int val = (unsigned)time( NULL );
	CString wname;
	wname = directoryX + "\\template";
	CString wext; 
	wext.Format("%d.htm",val);
	wname = wname  + wext;

	
	FILE* fpw = fopen(wname,"wb");
	if (fpw)
	{

		

		int len = templateStr.GetLength();
		fwrite(templateStr,len ,1,fpw);
		fclose(fpw);

	}



	if (sx>0)
	{
		CWordHTMLView* whv = (CWordHTMLView*) GetActiveView();
		if (whv)
		{
			if (whv->navPath!=_T(""))
				DeleteFile(whv->navPath);
			whv->navPath = wname;
			whv->PostMessage(WM_USER_GENERIC,0,0);
			
			//whv->Navigate2(wname,NULL,NULL);
			//whv->Invalidate();
		}
	
		//DragAcceptFiles(0);

	}


	accessingBuffer = 0;

	CFrameWnd::OnDropFiles(hDropInfo);
}
